function DisplayVideoElement(ContentElement){
    var self = this; self.name = "DisplayVideoElement"; // MANDATORY

    this.reference = -1;
    this.type = -1;
    this.switch = 0;
    this.relative_path = false;
    this.force_http_source = false;
    this.die = true;
    this.time_to_die = 1500;

    this.loaded = false;

    this.x = 0;
    this.y = 0;
    this.w = "100%";
    this.h = "100%";
    this.z = 1;

    this.ui = false;
    this.uiTimer = null;
    this.uiStartTime = 0;

    this.source = ContentElement.getSource();
    this.duration = ContentElement.getDuration();
    this.relative_path = ContentElement.relative_path;
    this.path = ContentElement.path;
    this.crossfade_time = ContentElement.getCrossfadeTime();
    this.is_stream = false;
    var ext = this.path.substring(this.path.lastIndexOf(".")+1,this.path.length);
    if(ext == "stream"){this.is_stream = true;}
    this.tag = "";
    this.direct_render = false;
    
    this.video_tag_reuse = false;
    
    this.video_started = false;
    this.poster = "";

    this.update = function(ContentElement){
        if(typeof(self.content) !== "undefined"){
          self.content = null;
        }
        self.content = ContentElement;
        self.source = ContentElement.getSource();
        self.duration = ContentElement.getDuration();
        self.relative_path = ContentElement.relative_path;
        self.path = ContentElement.path;
        self.crossfade_time = ContentElement.getCrossfadeTime();
        var ext = self.path.substring(self.path.lastIndexOf(".")+1,self.path.length);
        if(ext == "stream"){self.is_stream = true;}
    };
    
    this.load_poster = function(x,y,w,h,z){
      try{
        self.OS.fileExists(self.ROUTES['CONTENT'].path+"poster-"+self.reference+".jpg",function(exists,file_ref,params){
          if(exists){
            self.poster = self.OS.rootDir+self.ROUTES['CONTENT'].path+"poster-"+self.reference+".jpg";
          }else{
            self.log("No Poster available "+self.reference+"-poster on CONTENT folder");
          }
        });
      }catch(e){
        self.log("Could not check existance of "+self.reference+"-poster");
      }
      if(self.poster != ""){
        if($(".stage").find("#"+self.reference+"-poster").length <= 0){
          $(".stage").append('<img class="player-media" id="'+self.reference+"-poster"+'" src="'+self.poster+'">');
          $("#"+self.reference+"-poster").css("left",x);
          $("#"+self.reference+"-poster").css("top",y);
          $("#"+self.reference+"-poster").css("width",w);
          $("#"+self.reference+"-poster").css("height",h);
          $("#"+self.reference+"-poster").css('display','inline');
          self.log("Loading Poster "+self.reference+"-poster");
        }else{
          self.log("Already loaded Poster "+self.reference+"-poster");
        }
      }
    };
    
    this.show_poster = function(){
      //$("#"+self.reference+"-poster").show();
      $("#"+self.reference+"-poster").css('z-index','1');
      $("#"+self.reference+"-poster").css('visibility','visible');
    };
    
    this.createVideo = function(layer){
      var extra_features = "";
      try{
        if(self.platform != "WEBOS" && self.platform != "TIZEN" && self.platform != "SOC" && !self.video_tag_reuse){
          $("#"+self.tag).hide();
          $("#"+self.tag).remove();
        }else{
          if($(".stage").find("#"+self.tag).length > 0){
            if($("#"+self.tag).css("visibility") != "hidden"){
              if(self.platform == "WEBOS"){
                if(!self.direct_render){
                  $("#"+self.tag).css("visibility","hidden");
                }
              }else{
                $("#"+self.tag).css("visibility","hidden");
              }
            }
            self.disconnect();
            self.disable();
          }
        }
      }catch(e){
        self.log("TAG does not exist");
      }
      if(typeof(self.OS.uses_texture_graphics) !== "undefined"){
        if(self.OS.uses_texture_graphics){
          extra_features = "texture";
        }
      }
      if(self.platform == "WEB"){extra_features += " muted";}
      if(self.platform != "WEBOS" && self.platform != "TIZEN" && self.platform != "SOC" && !self.video_tag_reuse){
        $(".stage").append('<video class="player-media" id="'+self.tag+'" preload="auto" playsinline '+extra_features+'><source src=""></video>');
      }else{
        if($(".stage").find("#"+self.tag).length <= 0){
          $(".stage").append('<video class="player-media" id="'+self.tag+'" preload="auto" style="display:inline" playsinline '+extra_features+'><source src=""></video>');
        }
        if(self.direct_render){
          $("#"+self.tag).css("visibility","visible");
        }
      }     
    };

    this.load = function(direct_render){
        if(typeof(direct_render) !== "undefined"){self.direct_render = direct_render;}
        self.loaded = false;
        self.video_started = false;
        self.createVideo();
        $("#"+self.tag).one("canplay",self.onElementLoadComplete);
        if(!self.is_stream){
            self.log("Video Element Load :"+self.path);
            try{
                $("#"+self.tag).find("source").attr("src",self.path);
                $("#"+self.tag).load();
            }catch(e){
                self.notifyError(self.ERROR['DISPLAY_VIDEO_ELEMENT']+4,": Function load() failed : Video source exception :"+self.path+" on "+self.tag);
                self.onElementLoadSourceError();
            }
            self.log("Load on tag : "+$("#"+self.tag).attr("id"));
        }else{
            self.OS.readFile(self.path,self.onFileRead);
        }
        $("#"+self.tag).find("source").one("error",self.onElementLoadSourceError);
        $("#"+self.tag).one("error",self.onElementLoadError);
    };
    this.onFileRead = function(result){
        self.log("Load as stream on tag : "+$("#"+self.tag).attr("id"));
        try{
            self.log("Video Element Load :"+result);
            $("#"+self.tag).find("source").attr("src",result);
            $("#"+self.tag).load();
        }catch(e){
            self.notifyError(self.ERROR['DISPLAY_VIDEO_ELEMENT']+4,": Function onFileRead() failed : Video source stream exception :"+result+" on "+self.tag);
            self.onElementLoadSourceError();
        }
    };

    this.onVideoEvent = function(e){
        self.log("Video Event : "+e.type);
    };

    this.onElementLoadComplete = function(event){
        //self.getBenchmark("Video Element Load Complete");
        $("#"+self.tag).off();
        self.loaded = true;
        self.playstatus = "STOP";
        self.log("Loaded on tag :"+self.tag);
        if(typeof($("#"+self.tag)) !== "undefined"){
            if(typeof($("#"+self.tag).find("source")) !== "undefined"){
                $("#"+self.tag).find("source").off("error");
            }
            $("#"+self.tag).off("error");
            $("#"+self.tag).off("canplay");
        }
        $(self).trigger("DisplayElementLoaded");
        //
    };

    this.onElementLoadSourceError = function(){
        self.disable();
        self.playstatus = "INVALID";
        self.log("Source Error on tag :"+self.tag);
        $("#"+self.tag).find("source").attr("src",self.ROUTES['STYLE'].path+"invalid.webm");

        $("#"+self.tag).find("source").off("error");
        $("#"+self.tag).off("error");
        $("#"+self.tag).off("canplay");
        $("#"+self.tag).off();
        //$("#"+self.tag).one("canplay",self.onElementLoadComplete);
        $("#"+self.tag).load();
        self.log(" Loading Invalid Video WEBM info ...");
        $(self).trigger("DisplayElementError");
    	self.OS.id_content_now = "";
        self.notifyError(self.ERROR['DISPLAY_VIDEO_ELEMENT']+1,": Function onElementLoadSourceError() failed : Video source error :"+self.path);
    };

    this.onElementLoadError = function(event){
        self.notifyError(self.ERROR['DISPLAY_VIDEO_ELEMENT']+2,": Function onElementLoadError() failed : could not load :"+self.path);
        $("#"+self.tag).off("error",self.onElementLoadError);
        $("#"+self.tag).off("canplay",self.onElementLoadComplete);

        $("#"+self.tag).off("stalled",self.onElementLoadStalled);
        $("#"+self.tag).off();
        self.disable();
        self.playstatus = "INVALID";
        self.log("Load Error on tag :"+self.tag);
        $(self).trigger("DisplayElementError");
    };

    this.onElementLoadProgress = function(event){
        //self.log(" Progress");
    };

    this.onElementLoadStalled = function(event){
        $("#"+self.tag).off("error",self.onElementLoadError);
        $("#"+self.tag).off("canplay",self.onElementLoadComplete);

        $("#"+self.tag).off("stalled",self.onElementLoadStalled);
        //self.playstatus = "INVALID";
        self.log("Stall Error");
        self.notifyError(self.ERROR['DISPLAY_VIDEO_ELEMENT']+3,": Function onElementLoadError() failed : Video stall error :"+self.path);
        $(self).trigger("DisplayElementError");
    };

    this.onElementLoadBuffering = function(event){
        self.playstatus = "STOP";
        self.log("Buffering");
    };

    this.play = function(){      
        //self.getBenchmark("Video Show");
        //self.getBenchmark("Video Play !!!!!");
        if(self.crossfade_time <= 0){
          if(self.platform != "WEBOS" && self.platform != "TIZEN" && self.platform != "SOC" && !self.video_tag_reuse){
            $("#"+self.tag).show();
          }
          if(self.platform == "WEBOS"){
            if(!self.direct_render){
              $("#"+self.tag).css("visibility","visible");
            }
          }else{
            $("#"+self.tag).css("visibility","visible");
          }
          $("#"+self.tag).get(0).volume = self.volume;
          $("#"+self.tag).on("timeupdate",self.onTimeUpdate);
          if(self.duration > 0){
              // SECURITY TIMEOUT DURATION +2s
              self.timer = setTimeout(self.timeout,(self.duration+2)*1000);
          }
          self.log("Play : "+self.reference+" with duration : "+self.duration+" on tag :"+self.tag);
          //self.getBenchmark("Video Set Timers");
          $("#"+self.tag).get(0).currentTime = 0;
          $("#"+self.tag).get(0).play();
          $(self).trigger("DisplayElementPlay");
        }else{
          $("#"+self.tag).off("timeupdate",self.onTimeUpdate);
          $("#"+self.tag).get(0).volume = 0.0;
          $("#"+self.tag).volume = 0.0;
          self.log("Crossfading from : 0 to "+self.volume);
          $("#"+self.tag).css("opacity","0.0");
          var max_crossfade_accepted = self.duration*1000/2;
          if(self.crossfade_time >= max_crossfade_accepted){
            self.crossfade_time = max_crossfade_accepted;
          }
          $("#"+self.tag).animate({volume: self.volume,opacity:1.0}, self.crossfade_time);
          if(self.platform == "WEBOS"){
            if(!self.direct_render){
              $("#"+self.tag).css("visibility","visible");
            }
          }else{
            $("#"+self.tag).css("visibility","visible");
          }
          if(self.platform != "WEBOS" && self.platform != "TIZEN" && self.platform != "SOC" && !self.video_tag_reuse){
            $("#"+self.tag).show();
          }
          if(self.duration > 0){
            self.timer = setTimeout(self.timeout,(self.duration*1000)-self.crossfade_time);
          }else{
            self.timer = setTimeout(self.timeout,10000);
          }
          self.log("Play : "+self.reference+" with duration : "+self.duration+" on tag :"+self.tag);
          //self.getBenchmark("Video Set Timers");
          $("#"+self.tag).get(0).currentTime = 0;
          $("#"+self.tag).get(0).play();
          setTimeout(function(){
            $(self).trigger("DisplayElementPlay");
          },self.crossfade_time);
        }
    };

    this.onTimeUpdate = function(e){
        if(!self.video_started){
          if(self.poster != "" && e.currentTarget.currentTime > 0.1){
            self.video_started = true;
            $("#"+self.reference+"-poster").css('visibility','hidden');
            $("#"+self.reference+"-poster").remove();
          }
        }
        //self.log("Video current time : "+e.currentTarget.currentTime+" of "+e.currentTarget.duration);
        if(e.currentTarget.currentTime>=e.currentTarget.duration){
            self.log("Reached end of time on tag :"+self.tag+" Died ? "+self.die);
            clearTimeout(self.timer);
            if($("#"+self.tag)){
                $("#"+self.tag).off("timeupdate");
                $("#"+self.tag).get(0).pause();
            }
            $("#"+self.tag).off();
            $(self).trigger("DisplayElementFinish");
        }
    };

    this.timeout = function(){
        clearTimeout(self.timer);        
        if(self.die){
            if(self.crossfade_time <= 0){         
              if($("#"+self.tag)){
                  $("#"+self.tag).off("timeupdate",self.onTimeUpdate);
                  if(typeof($("#"+self.tag).get(0)) !== "undefined"){
                    $("#"+self.tag).get(0).pause();
                  }
              }
              $("#"+self.tag).off();
              self.playstatus = "STOP";
              $(self).trigger("DisplayElementFinish");
              self.log("Ended by timeout on tag :"+self.tag+" Died ? "+self.die);
            }else{
              $("#"+self.tag).off();
              self.playstatus = "STOP";
              $(self).trigger("DisplayElementFinish");
              self.log("Ended by timeout on tag :"+self.tag+" Died ? "+self.die+" Crossfading ....");
            }
        }
    };

    this.connect = function(ui){
        if($("#"+self.tag)){
            if(ui.active){
                $("#"+self.tag).attr("controls","controls");
            }
        }
    };

    this.disconnect = function(){
        if($("#"+self.tag)){
            $("#"+self.tag).removeAttr("controls");
        }
    };

     this.disable = function(){
        if($("#"+self.tag)){
            $("#"+self.tag).off("loadstart");
            $("#"+self.tag).off("canplay");
            $("#"+self.tag).off("progress");
            $("#"+self.tag).off("stalled");
            $("#"+self.tag).off("waiting");
            $("#"+self.tag).off("timeupdate");
        }
    };

    this.clear_source = function(){
        $("#"+self.tag).find("source").attr("src","");
        $("#"+self.tag).find("source").removeAttr("src");
        //$("#"+self.tag).find("source").remove();
        try{
          if(self.platform != "WEBOS" && self.platform != "TIZEN" && self.platform != "SOC" && !self.video_tag_reuse){
            $("#"+self.tag).remove();
          }
        }catch(e){
          self.log("TAG does not exist");
        }
    };

    // COMMON
    this.vanish = function(){
      if(self.crossfade_time <= 0){    
        if($("#"+self.tag)){
          $("#"+self.tag).off("timeupdate",self.onTimeUpdate);
          if(typeof($("#"+self.tag).get(0)) !== "undefined"){
            $("#"+self.tag).get(0).pause();
          }
          if($("#"+self.tag).css("visibility") != "hidden"){
            
            if(self.platform == "SOC"){
              $("#"+self.tag).css("z-index","-1");
            }else{
              $("#"+self.tag).css("z-index","0");
            }
            if(self.platform == "WEBOS"){
              if(!self.direct_render){
                $("#"+self.tag).css("visibility","hidden");
              }
            }else{
              $("#"+self.tag).css("visibility","hidden");
            }
            if(self.platform != "WEBOS" && self.platform != "TIZEN" && self.platform != "SOC" && !self.video_tag_reuse){
              $("#"+self.tag).hide();
            }    
          }
        }
      }else{
        if(self.tag !== ""){
          //$("#"+self.tag).fadeOut(self.crossfade_time,function(){$("#"+self.tag).css("visibility","hidden");$("#"+self.tag).css("z-index","0");}); 
          if(typeof($("#"+self.tag).get(0)) !== "undefined"){
            $("#"+self.tag).animate({volume: 0.0,opacity:0.0}, self.crossfade_time);
          }
        }
      }
    };

    this.destroy = function(time){
        self.loaded = false;
        clearTimeout(self.timer);
        self.disconnect();
        if(typeof(time) === 'undefined'){ time = 0; }
        self.disable();
        if(time == 0){
            self.vanish();
            self.clear_source();
        }else{
          if(self.crossfade_time > 0){
            time = self.crossfade_time;
          }
            setTimeout(function(){
                self.vanish();
                self.clear_source();
            },time);
        }
        self.log(self.reference+" destroyed ... on tag : "+self.tag);
    };

    this.modifyViewer = function(x,y,w,h,z){
        if(typeof(z) === 'undefined'){z=1;}
        self.x = x;
        self.y = y;
        self.w = w;
        self.h = h;
        self.z = z;
    };

    this.setViewer = function(){
        $("#"+self.tag).css("left",self.x);
        $("#"+self.tag).css("top",self.y);
        $("#"+self.tag).css("width",self.w);
        $("#"+self.tag).css("height",self.h);
        $("#"+self.tag).css("z-index",self.z);
    };
}
DisplayVideoElement.prototype = new SystemController();
